      *===============================================================*                       RADDAT
     H DEBUG                                                                                  RADDAT
     H OPTION(*SRCSTMT : *NODEBUGIO)                                                          RADDAT
     H DECEDIT('0,') DATEDIT(*DMY.)                                                           RADDAT
     H DATFMT(*ISO )  TIMFMT(*ISO )                                                           RADDAT
     H EXPROPTS(*RESDECPOS)                                                                   RADDAT
     H EXTBININT(*YES)                                                                        RADDAT
     H DFTACTGRP(*NO) ACTGRP(*NEW)                                                            RADDAT
      *===============================================================*                       RADDAT
      *                                                                                       RADDAT
     D PGM_ENTRY_POINT...                                                                     RADDAT
     D                 PR                  extpgm('TEST_F202')                                RADDAT
     D gi_version                    32A   const                                              RADDAT
      *                                                                                       RADDAT
     D main...                                                                                RADDAT
     D                 PR                         extproc('main')                             RADDAT
     D i_version                     32A   value  varying options(*trim)                      RADDAT
      *                                                                                       RADDAT
      *  Get Version Number                                                                   RADDAT
     D http_getVersion...                                                                     RADDAT
     D                 PR            32A          varying                                     RADDAT
     D i_version                     32A   value  varying options(*trim)                      RADDAT
      *                                                                                       RADDAT
      *  Sends a message to QCMD                                                              RADDAT
     D sndMsg...                                                                              RADDAT
     D                 PR                         extproc('sndMsg')                           RADDAT
     D  i_text                      128A   value  varying                                     RADDAT
      *                                                                                       RADDAT
      *===============================================================*                       RADDAT
      *  Program Entry Point                                                                  RADDAT
      *===============================================================*                       RADDAT
     D PGM_ENTRY_POINT...                                                                     RADDAT
     D                 PI                                                                     RADDAT
     D gi_version                    32A   const                                              RADDAT
      *                                                                                       RADDAT
     D HTTPAPI_VERSION...                                                                     RADDAT
     D                 C                   CONST('1.24beta10')                                RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         if (%parms() >= 1);                                                                //RADDAT
            main( gi_version );                                                             //RADDAT
         else;                                                                              //RADDAT
            main( HTTPAPI_VERSION );                                                        //RADDAT
         endif;                                                                             //RADDAT
                                                                                            //RADDAT
         *inlr = *on;                                                                       //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
      *                                                                                       RADDAT
      *===============================================================*                       RADDAT
      *  *** private ***                                                                      RADDAT
      *  Sends a message to the caller.                                                       RADDAT
      *===============================================================*                       RADDAT
     P sndMsg...                                                                              RADDAT
     P                 B                                                                      RADDAT
      *                                                                                       RADDAT
     D sndMsg...                                                                              RADDAT
     D                 PI                                                                     RADDAT
     D  i_text                      128A   value  varying                                     RADDAT
      *                                                                                       RADDAT
      *  Return value                                                                         RADDAT
     D pBuffer         S               *   inz                                                RADDAT
      *                                                                                       RADDAT
      *  Local fields                                                                         RADDAT
     D msgKey          S              4A                        inz                           RADDAT
      *                                                                                       RADDAT
     D qMsgF           DS                  qualified            inz                           RADDAT
     D  name                         10A                                                      RADDAT
     D  lib                          10A                                                      RADDAT
      *                                                                                       RADDAT
     D errCode         DS                  qualified            inz                           RADDAT
     D  bytPrv                       10I 0                                                    RADDAT
     D  bytAvl                       10I 0                                                    RADDAT
     D  excID                         7A                                                      RADDAT
     D  reserved                      1A                                                      RADDAT
     D  excDta                      256A                                                      RADDAT
      *                                                                                       RADDAT
      *  Send Program Message (QMHSNDPM) API                                                  RADDAT
     D QMHSNDPM        PR                         extpgm('QMHSNDPM')                          RADDAT
     D   i_msgID                      7A   const                                              RADDAT
     D   i_qMsgF                     20A   const                                              RADDAT
     D   i_msgData                32767A   const  options(*varsize )                          RADDAT
     D   i_length                    10I 0 const                                              RADDAT
     D   i_msgType                   10A   const                                              RADDAT
     D   i_callStkE               32767A   const  options(*varsize )                          RADDAT
     D   i_callStkC                  10I 0 const                                              RADDAT
     D   o_msgKey                     4A                                                      RADDAT
     D   io_ErrCode               32767A          options(*varsize )                          RADDAT
     D   i_lenStkE                   10I 0 const  options(*nopass  )                          RADDAT
     D   i_callStkEQ                 20A   const  options(*nopass  )                          RADDAT
     D   i_wait                      10I 0 const  options(*nopass  )                          RADDAT
     D   i_callStkEDT                10A   const  options(*nopass  )                          RADDAT
     D   i_ccsid                     10I 0 const  options(*nopass  )                          RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         clear qMsgF;                                                                       //RADDAT
         qMsgF.name = 'QCPFMSG';                                                            //RADDAT
         qMsgF.lib  = '*LIBL';                                                              //RADDAT
                                                                                            //RADDAT
         clear errCode;                                                                     //RADDAT
         errCode.bytPrv = %size(errCode);                                                   //RADDAT
                                                                                            //RADDAT
         QMHSNDPM('CPF9897': qMsgF: i_text: %len(i_text): '*INFO'
                  : '*CTLBDY': 1
                  : msgKey: errCode);                                                       //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
      *                                                                                       RADDAT
     P sndMsg...                                                                              RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      *===============================================================*                       RADDAT
      *  Get Version Number                                                                   RADDAT
      *===============================================================*                       RADDAT
     P http_getVersion...                                                                     RADDAT
     P                 B                                                                      RADDAT
      *                                                                                       RADDAT
     D http_getVersion...                                                                     RADDAT
     D                 PI            32A          varying                                     RADDAT
     D i_version                     32A   value  varying options(*trim)                      RADDAT
      *                                                                                       RADDAT
      *  Return value                                                                         RADDAT
     D version         s             32A   varying inz                                        RADDAT
      *                                                                                       RADDAT
      *  Helper fields                                                                        RADDAT
     D s               s             10i 0 inz                                                RADDAT
     D e               s             10i 0 inz                                                RADDAT
     D nbr             s              3s 0 inz                                                RADDAT
     D isFinalVersion  s               n   inz                                                RADDAT
      *                                                                                       RADDAT
     D BETA            c                   'beta'                                             RADDAT
     D UPPER           C                   'ABCDEFGHIJKLMNOPQRSTUVWXYZ'                       RADDAT
     D LOWER           C                   'abcdefghijklmnopqrstuvwxyz'                       RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         // Ensure that all characters are lower case                                       //RADDAT
         i_version = %xlate(upper: lower: i_version);                                       //RADDAT
                                                                                            //RADDAT
         // Retrieve major version number                                                   //RADDAT
         s = 1;                                                                             //RADDAT
         e = %scan('.': i_version);                                                         //RADDAT
         if (e <= s);                                                                       //RADDAT
            return '*ERR_DOT';   // The dot after the major version number is missing       //RADDAT
         endif;                                                                             //RADDAT
                                                                                            //RADDAT
         nbr = %dec(%subst(i_version: s: e-s): 3: 0);                                       //RADDAT
         version = %editc(nbr: 'X');                                                        //RADDAT
                                                                                            //RADDAT
         // Retrieve minor version number                                                   //RADDAT
         s = e + 1;                                                                         //RADDAT
         e = %scan(BETA: i_version: s);                                                     //RADDAT
         if (e = 0);   // must be a final version                                           //RADDAT
            e = %len(i_version) + 1;                                                        //RADDAT
            isFinalVersion = *on;                                                           //RADDAT
         else;                                                                              //RADDAT
            isFinalVersion = *off;                                                          //RADDAT
         endif;                                                                             //RADDAT
                                                                                            //RADDAT
         if (e <= s);                                                                       //RADDAT
            return '*ERR_MINOR_NBR';   // Minor version number is missing                   //RADDAT
         endif;                                                                             //RADDAT
                                                                                            //RADDAT
         nbr = %dec(%subst(i_version: s: e-s): 3: 0);                                       //RADDAT
         version = version + '.' + %editc(nbr: 'X');                                        //RADDAT
                                                                                            //RADDAT
         // Retrieve beta number                                                            //RADDAT
         if (isFinalVersion);                                                               //RADDAT
            nbr = *hival;                                                                   //RADDAT
         else;                                                                              //RADDAT
            s = e + %len(BETA);                                                             //RADDAT
            e = %len(i_version) + 1;                                                        //RADDAT
            if (e <= s);                                                                    //RADDAT
               return '*ERR_BETA_NBR';   // Beta build number is missing                    //RADDAT
            else;                                                                           //RADDAT
               nbr = %dec(%subst(i_version: s: e-s): 3: 0);                                 //RADDAT
            endif;                                                                          //RADDAT
         endif;                                                                             //RADDAT
                                                                                            //RADDAT
         version = version + '-' + %editc(nbr: 'X');                                        //RADDAT
                                                                                            //RADDAT
         return version;                                                                    //RADDAT
                                                                                            //RADDAT
      /END-FREE
      *                                                                                       RADDAT
     P http_getVersion...                                                                     RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
      *===============================================================*                       RADDAT
      *  Main procedure                                                                       RADDAT
      *===============================================================*                       RADDAT
     P main...                                                                                RADDAT
     P                 B                                                                      RADDAT
      *                                                                                       RADDAT
     D main...                                                                                RADDAT
     D                 PI                                                                     RADDAT
     D i_version                     32A   value  varying options(*trim)                      RADDAT
      *                                                                                       RADDAT
      *  Helper fields                                                                        RADDAT
     D version         s             32a   varying inz                                        RADDAT
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                         RADDAT
      /FREE
                                                                                            //RADDAT
         // Do until everything is done or an error occured                                 //RADDAT
         dou '1';                                                                           //RADDAT
                                                                                            //RADDAT
            version = http_getVersion(i_version);                                           //RADDAT
            sndMsg(version);                                                                //RADDAT
                                                                                            //RADDAT
         enddo;                                                                             //RADDAT
                                                                                            //RADDAT
         return;                                                                            //RADDAT
                                                                                            //RADDAT
      /END-FREE
      *                                                                                       RADDAT
     P main...                                                                                RADDAT
     P                 E                                                                      RADDAT
      *                                                                                       RADDAT
